SET ROLE :db_adm;
BEGIN;
-- Log the update
INSERT INTO db_history (beschreibung, zeitpunkt) 
	VALUES ('update_1_0_2/06_create_role.sql', current_timestamp);

-- ------------------------------------------------------------------------
-- Anlegen einer Rolle in der DB einer KA:
-- - Ueber waska_create_role() Datenbank-Rolle anlegen und 
-- - dann Eintragungen in ka_benutzer_tbl machen.
CREATE OR REPLACE FUNCTION ka_create_role (
        agency          varchar(52),
        grouprole       varchar(64),
        loginname       varchar(64),
        firstname       varchar(64),
        surname         varchar(64),
        phone           varchar(64),
        room            varchar(64),
        branchoffice    varchar(64),
        activated       boolean,
        setpassword     boolean
    ) RETURNS varchar(9) 
    LANGUAGE 'plpgsql' VOLATILE EXTERNAL SECURITY DEFINER
    AS $$
DECLARE
    newrole    RECORD;
    groupid    integer;
    userid     integer;
BEGIN
    SELECT INTO newrole * FROM waska_create_role(loginname, grouprole, agency)
        AS (db_name varchar(64), db_user varchar(64), pw varchar(9));
    EXECUTE 'GRANT CONNECT ON DATABASE ' || newrole.db_name 
                || ' TO ' || newrole.db_user; 
    INSERT INTO ka_benutzer_tbl ( login, vorname, nachname,
        telefon, raumnummer, filiale,
        aktiviert, passwort_aendern, gid) 
        VALUES
        (newrole.db_user, firstname, surname,
        phone, room, branchoffice,
        activated, setpassword, NULL);
    SELECT INTO userid currval('ka_benutzer_tbl_id_seq');
    SELECT INTO groupid create_benutzergruppe_ds(surname ||', '|| firstname ||' ('||loginname||')');
    UPDATE ka_benutzer_tbl SET gid = groupid WHERE id = userid;
    INSERT INTO nm_benutzer_gruppe_tbl (benutzer_id, gruppe_id) VALUES (userid, groupid);

    RETURN newrole.pw::varchar(9);
END;
$$ ;

REVOKE ALL ON FUNCTION ka_create_role(varchar, varchar, varchar, 
    varchar, varchar, varchar, varchar, varchar, boolean, boolean) 
        FROM PUBLIC;
GRANT EXECUTE ON FUNCTION ka_create_role(varchar, varchar, varchar, 
    varchar, varchar, varchar, varchar, varchar, boolean, boolean) 
        TO GROUP :admin_ka_group;

COMMIT;
