--
-- Korrektur bestehender Datenbanken: 
-- Der Rolle public alle Berechtigungen entziehen
-- 
-- Frank Koormann <frank@intevation.de>
-- 04.02.2008
--

BEGIN;
REVOKE ALL ON SCHEMA public FROM PUBLIC;
GRANT USAGE ON SCHEMA public TO :cm_ka_group;
GRANT USAGE ON SCHEMA public TO :admin_ka_group;
GRANT USAGE ON SCHEMA public TO waska_role_adm; 
GRANT ALL ON SCHEMA public TO :adm_ka_owner;

REVOKE ALL ON FUNCTION case_exists(knummer character varying) FROM PUBLIC;
REVOKE ALL ON FUNCTION create_fall_dokument_ds(mid integer) FROM PUBLIC;
REVOKE ALL ON FUNCTION create_global_dokument_ds() FROM PUBLIC;
REVOKE ALL ON FUNCTION create_nm_benutzer_master_ds(userid integer, masterid integer) FROM PUBLIC;
GRANT EXECUTE ON FUNCTION create_nm_benutzer_master_ds(integer, integer) TO GROUP :admin_ka_group;
REVOKE ALL ON FUNCTION create_rg_massnahme_ds(mid integer) FROM PUBLIC;
REVOKE ALL ON FUNCTION create_rg_sprache_ds(rgid integer) FROM PUBLIC;
REVOKE ALL ON FUNCTION create_status_ds(mid integer) FROM PUBLIC;
REVOKE ALL ON FUNCTION delete_fall_dokument_ds(did integer) FROM PUBLIC;
REVOKE ALL ON FUNCTION delete_global_dokument_ds(did integer) FROM PUBLIC;
REVOKE ALL ON FUNCTION delete_master_ds(mid integer) FROM PUBLIC;
REVOKE ALL ON FUNCTION delete_nm_benutzer_master_ds(userid integer, masterid integer) FROM PUBLIC;
REVOKE ALL ON FUNCTION delete_rg_beruf_ds(dsid integer) FROM PUBLIC;
REVOKE ALL ON FUNCTION delete_rg_bilden_ds(dsid integer) FROM PUBLIC;
REVOKE ALL ON FUNCTION delete_rg_leben_ds(dsid integer) FROM PUBLIC;
REVOKE ALL ON FUNCTION delete_rg_quali_ds(dsid integer) FROM PUBLIC;
REVOKE ALL ON FUNCTION getoid() FROM PUBLIC;
REVOKE ALL ON FUNCTION getrole(user_id integer) FROM PUBLIC;
REVOKE ALL ON FUNCTION gettotal() FROM PUBLIC;
REVOKE ALL ON FUNCTION gettotalcm() FROM PUBLIC;
REVOKE ALL ON FUNCTION getuserid() FROM PUBLIC;
REVOKE ALL ON FUNCTION iseditororstandin(mid integer) FROM PUBLIC;
REVOKE ALL ON FUNCTION ka_create_role(agency character varying, grouprole character varying, loginname character varying, firstname character varying, surname character varying, phone character varying, room character varying, branchoffice character varying, activated boolean, setpassword boolean) FROM :cm_ka_group;
REVOKE ALL ON FUNCTION ka_create_role(agency character varying, grouprole character varying, loginname character varying, firstname character varying, surname character varying, phone character varying, room character varying, branchoffice character varying, activated boolean, setpassword boolean) FROM PUBLIC;
GRANT EXECUTE ON FUNCTION ka_create_role(varchar, varchar, varchar, varchar, varchar, varchar, varchar, varchar, boolean, boolean) TO GROUP :admin_ka_group;
REVOKE ALL  ON FUNCTION  waska_create_role(username character varying, grouprole character varying, agency character varying) FROM :admin_ka_group;

REVOKE ALL ON FUNCTION ka_delete_role(loginname character varying, agency character varying) FROM PUBLIC;
REVOKE ALL ON FUNCTION waska_revoke_connect(username character varying, agency character varying) FROM :admin_ka_group;
REVOKE ALL ON FUNCTION ka_set_password("login" character varying, pw character varying) FROM PUBLIC;
REVOKE ALL ON FUNCTION ka_set_standin(standin_id integer, user_id integer) FROM PUBLIC;
REVOKE ALL ON FUNCTION ka_unset_passrefresh_flag(userlogin character varying) FROM PUBLIC;
REVOKE ALL ON FUNCTION set_case_editor(userid integer, masterid integer) FROM PUBLIC;

--
-- Entziehen der Berechtigungen fr neue Objekte (Sichten und Funktionen)
--
REVOKE ALL ON FUNCTION generate_uuidgen() FROM public;
GRANT EXECUTE ON FUNCTION generate_uuidgen() TO GROUP :cm_ka_group;
GRANT EXECUTE ON FUNCTION generate_uuidgen() TO GROUP :admin_ka_group;
GRANT EXECUTE ON FUNCTION generate_uuidgen() TO GROUP :adm_ka_owner;
REVOKE ALL ON FUNCTION set_uuid(TEXT, INT) FROM public;
REVOKE ALL ON FUNCTION create_master_ds(CHAR(36)) FROM PUBLIC;
REVOKE ALL ON FUNCTION create_rg_beruf_ds(INTEGER, CHAR(36)) FROM PUBLIC;
REVOKE ALL ON FUNCTION create_rg_bilden_ds(INTEGER, CHAR(36)) FROM PUBLIC;
REVOKE ALL ON FUNCTION create_rg_leben_ds(INTEGER, CHAR(36)) FROM PUBLIC;
REVOKE ALL ON FUNCTION create_rg_quali_ds(INTEGER, CHAR(36)) FROM PUBLIC;
REVOKE ALL ON FUNCTION create_rg_kompetenz_ds(INTEGER, CHAR(36)) FROM PUBLIC;

REVOKE ALL ON FUNCTION ka_delete_role(varchar, varchar) FROM GROUP :cm_ka_group;
COMMIT;
