BEGIN;
--
-- Temporary function to anonymize all case which
-- have a revoked privacy statement.
--
CREATE OR REPLACE FUNCTION anoymize_cases_without_statement() 
RETURNS VOID AS 
$$
DECLARE
    t_row RECORD;
BEGIN
    FOR t_row IN SELECT id FROM master_tbl_view WHERE einverstaendniserklaerung = 0
    LOOP
        PERFORM anonymize_case(t_row.id);
        -- remove attachments directly to avoid access problems.
        DELETE FROM ka_dokumente_tbl WHERE master_id = t_row.id;
        UPDATE ka_status_tbl_view SET status = 5 WHERE master_id = t_row.id;
    END LOOP;
END;
$$ LANGUAGE plpgsql;

SELECT anoymize_cases_without_statement();

--
-- not needed any longer
--
DROP FUNCTION anoymize_cases_without_statement();

COMMIT;

