# -*- coding: utf-8 -*-
#
# Copyright 2007, 2008 Intevation GmbH, Germany, <info@intevation.de>
# 
# This file is part of mpuls WASKA (CoMPUter-based case fiLeS - 
# Web-Anwendungs-Server fuer Kompetenzagenturen).
# 
# mpuls WASKA is free software: you can redistribute it and/or modify it under
# the terms of the GNU Affero General Public License as published by the
# Free Software Foundation, either version 3 of the License, or (at your
# option) any later version.
# 
# mpuls WASKA is distributed in the hope that it will be useful, but WITHOUT
# ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or
# FITNESS FOR A PARTICULAR PURPOSE.  See the GNU Affero General Public
# License for more details.
# 
# You should have received a copy of the GNU Affero General Public
# License along with mpuls WASKA. If not, see <http://www.gnu.org/licenses/>.
# 
# mpuls WASKA has been developed on behalf of the 
# Projekttraeger im Deutschen Zentrum fuer Luft- und Raumfahrt e.V. (PT-DLR)
# within the programme Kompetenzagenturen (Durchfuehrungsphase) funded by
# the Bundesministerium fuer Familie, Senioren, Frauen und Jugend and 
# European Social Fund resources.
# Authors:
# Sascha L. Teichmann <teichmann@intevation.de>
#

import logging
import logging.handlers as handlers

from threading import Lock

import sys

MAX_TIME_LIST_LEN = 5

__TIME_LOCK = Lock()

__TIME_LIST = []

__LOGGER = None

def setupTimeLogging(host='localhost', port=handlers.DEFAULT_TCP_LOGGING_PORT):
    if host: host = host.strip()
    if host:
        print >> sys.stderr, "time logging: %s port %d" % (host, port)
        global __LOGGER 
        __LOGGER = logging.getLogger('waska.timelog')
        socketHandler = handlers.SocketHandler(host, port)
        __LOGGER.addHandler(socketHandler)
        __LOGGER.setLevel(logging.INFO)
    else:
        print >> sys.stderr, "time logging deactivated"

def timeLog(t):
    try:
        __TIME_LOCK.acquire()
        if __LOGGER is None:
            return

        if len(__TIME_LIST) < MAX_TIME_LIST_LEN-1:
            __TIME_LIST.append(t)
        else:
            __TIME_LIST.append(t)
            avg = float(sum(__TIME_LIST))/MAX_TIME_LIST_LEN
            del __TIME_LIST[:]
            __LOGGER.info("%f" % avg)
    finally:
        __TIME_LOCK.release()
        

# vim:set ts=4 sw=4 si et sta sts=4 fenc=utf8:
